//
//  JSONParser.m
//  WeatherParser
//
//  Created by kelley.ricker on 12/16/15.
//  Copyright © 2015 GrapeCity. All rights reserved.
//

#import "JSONParser.h"
#import "WeatherData.h"
#import "FetchWeatherData.h"

@implementation JSONParser
-(id)initWithArray: (NSMutableArray *) array{
    self = [super init];
    if (self) {
        self.array = array;
    }
    return self;
}
-(void)parseDataFor:(FlexGrid *) grid{
    [FetchWeatherData placeJSONGetRequest:@"15232" withHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
        
        NSMutableDictionary *fullData = [ NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:&error];
        
        NSArray* forecastList = fullData[@"list"];
        NSDictionary *temp = [[NSDictionary alloc]init];
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
        
        for (NSDictionary* forecastDictionary in forecastList) {
            
            WeatherData *forecastData = [[WeatherData alloc] init];
            NSArray *weather = forecastDictionary[@"weather"];
            temp = forecastDictionary[@"main"];
            
            forecastData.date = [dateFormatter dateFromString:(NSString *)forecastDictionary[@"dt_txt"]];
            forecastData.highTemp = temp[@"temp_max"];
            forecastData.lowTemp = temp[@"temp_min"];
            forecastData.humidity = temp[@"humidity"];
            forecastData.pressure = temp[@"pressure"];
            
            for (NSDictionary* weatherDictionary in weather) {
                forecastData.weatherDescription = weatherDictionary[@"description"];
            }
            
            [self.array addObject:forecastData];
        }
        dispatch_async(dispatch_get_main_queue(), ^{
            grid.itemsSource = self.array;
        });
    }];
}
@end
